""" Copyright 2008 Joseph Bergin
License: Creative Commons Attribution-Noncommercial-Share Alike 3.0 United States License

 A simple trace facility that demonstrates the use of the Observer Design pattern
All robots are observable and yield up their new state when they perform primitive actions.
This class just shows part of that state. 
"""

from karel.observable import Observer


class Tracer(Observer):
    
    def __init__(self, robot, tag):
        robot.addObserver(self)
        self.__tag = tag
        
    def update(self, robot, state):
        "Expects to get a RobotState object"
        running = "running"
        if not state.isRunning() :
            running = "not " + running
        if state.beepers() < 0 :
            beepers = "an INFINITY of"
        else :
            beepers = str(state.beepers())
        print (self.__tag + " at: (" + str(state.street()) + ", " + str(state.avenue()) + ") facing: " + \
            state.direction().__name__ + " with: " + beepers + " beeper(s) " + running)