''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 48

from karel.robota import UrRobot
from karel.robota import East
from karel.robota import world

class Harvester(UrRobot):
    def harvestTwoRows(self):
        ''' Before executing this, the robot should be facing East,
           on the first beeper of the current row.  
        '''
        self._harvestOneRow()
        self._goToNextRow()
        self._harvestOneRow()
    
    def positionForNextHarvest(self):
        ''' Before executing this, the robot should be facing West,
           on the last corner of the current row.
        '''
        self.turnRight()
        self.move()
        self.turnRight()
    
    def turnRight(self):
        self.turnLeft()
        self.turnLeft()
        self.turnLeft()
        
    def _harvestOneRow(self):
        self._harvestCorner()
        self.move()
        self._harvestCorner()
        self.move()
        self._harvestCorner()
        self.move()
        self._harvestCorner()
        self.move()
        self._harvestCorner()
    
    def _harvestCorner(self):
        self.pickBeeper()
        
    def _goToNextRow(self):
        ''' Before executing this, the robot should be facing East,
           on the last corner of the current row. 
        '''
        self.turnLeft()
        self.move()
        self.turnLeft() 

if __name__ == '__main__' :
    world.readWorld("../fig3-2.kwld")
    world.setDelay(10)
    mark =  Harvester(2, 2, East, 0)
    mark.move()
    mark.harvestTwoRows()
    mark.positionForNextHarvest()
    mark.harvestTwoRows()
    mark.positionForNextHarvest()
    mark.harvestTwoRows()
    mark.move()
    mark.turnOff()