""" Copyright 2008 Joseph Bergin
License: Creative Commons Attribution-Noncommercial-Share Alike 3.0 United States License

BeeperLayer from Chapter 4.2
    Demonstrates simple polymorphism via inheritance
"""


from karel.robota import UrRobot
from karel.robota import East
from karel.robotworld import infinity
from karel.robota import world

class BeeperLayer(UrRobot):
    
#    def placeBeepers(self):
#        "What to do?"
#        raise NotImplemented
    
    def layBeepers(self):
        "Puts beepers on five corners as defined by a subclass"
        self.move()
        self.placeBeepers()
        self.move()
        self.placeBeepers()
        self.move()
        self.placeBeepers()
        self.move()
        self.placeBeepers()        
        self.move()
        self.placeBeepers()
        self.move()
        
class TwoRowLayer(BeeperLayer):
    "Puts two beepers on each corner when asked to layBeepers"
    def placeBeepers(self):
        self.putBeeper()
        self.putBeeper()
        
class ThreeRowLayer(BeeperLayer):
    "Puts three beepers on each corner when asked to layBeepers"
    def placeBeepers(self):
        self.putBeeper()
        self.putBeeper()
        self.putBeeper()
        
        
def task():
    lisa = TwoRowLayer(1, 3, East, infinity)
    lisa.layBeepers()
    lisa = ThreeRowLayer(2, 3, East, infinity)
    lisa.layBeepers()
    lisa = TwoRowLayer(3, 3, East, infinity)
    lisa.layBeepers()
    lisa = ThreeRowLayer(4, 3, East, infinity)
    lisa.layBeepers()
    lisa = TwoRowLayer(5, 3, East, infinity)
    lisa.layBeepers()
    world.showWorldWithRobots(1, 1, 6, 10)
    world.showBeepers()
    world.showWalls()
    
if __name__ == '__main__' :    
    from karel.robota import window
    world.setSize(12,12)
    world.showWorldWithRobots()
    window().run(task) #note the robot is created within the task
