''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 93

class Spy(UrRobot):
    "Knows how to follow strategies given by accomplices"
    def __init__(self, street, avenue, direction, beepers, 
		initialStrategy):
        UrRobot.__init__(self, street, avenue, direction, beepers)
        self.__strategy = initialStrategy
        
    def getNextClue(self):
        """Get the next part of the puzzle from the accomplice.
        Must be on the same corner as the accomplice to get the strategy
        """
        robot = self.neighbors().pop()
        self.__strategy = robot.requestClue()
        
    def followStrategy(self):
        "Follow the current strategy. Usually the one just obtained. "
        self.__strategy.doIt(self)
