""" Copyright 2008 Joseph Bergin
License: Creative Commons Attribution-Noncommercial-Share Alike 3.0 United States License

 A general strategy interface with the associated null implementation
"""

class Strategy:
    "An interface to define strategies. Subclass this to define concrete strategies." 
    def doIt(self, robot):
        raise NotImplementedError ("Unimplemented Strategy")
    
    
class NullStrategy(Strategy):
    "An implementation in which doIt does nothing at all"
    def doIt(self, robot):
        pass