''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 88

class StrategyLayer(BeeperLayer):
    "Uses a strategy to determine how to placeBeepers"

    def __init__(self, street, avenue, direction, beepers):
        "Initially does nothing when asked to putBeepers"
        BeeperLayer.__init__(self, street, avenue, direction, beepers)
        self.__strategy = NullStrategy()
        
    def setStrategy(self, strategy):
        "Change the current strategy to any other"
        self.__strategy = strategy
        
    def placeBeepers(self):
        "Delegate the action to the strategy"
        self.__strategy.doIt(self)
