''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 99

class WalkListener(UrRobot, Observer):
    """Moves whenever the observed robot picks a beeper
    Note that these objects are both robots and observers (of robots). 
    """

    def __init__(self, street, avenue, direction, beepers, observed):
        UrRobot.__init__(self, street, avenue, direction, beepers)
        observed.addObserver(self)
        
    def update(self, robot, state):
        "Message sent by the observed robot"
        if state.action() == UrRobot.pickBeeperAction :
            self.move()

if __name__ == '__main__':
    world.placeBeepers(1, 1, 9)
    james = UrRobot(1, 1, East, 0)
    gloria = WalkListener(2, 1, East, 0, james)
    james.pickBeeper()
    james.pickBeeper()
    james.pickBeeper()
    james.pickBeeper()
    james.pickBeeper()
    james.move()
