""" Copyright 2008 Joseph Bergin
License: Creative Commons Attribution-Noncommercial-Share Alike 3.0 United States License

 Sample illustration from Chapter 8. These robots are set up to run in different threads.
The setupThread message to the world enables it and the run method is executed when the world
starts the threads. 
"""

from karel.robota import Robot
from karel.robota import world

class Racer(Robot):
    "Illustrates classic race conditions among threads."
    
    def __init__(self, street, avenue, direction):
        Robot.__init__(self, street, avenue, direction, 0)
        world.setupThread(self)
        
    def race(self):
        "Race for the beeper"
        while not self.nextToABeeper() :
            self.move()
        self.pickBeeper()
        self.turnLeft()
        self.turnLeft()
        self.move()
        
    def run(self):
        "Runs the race in its own thread"
        self.race()
        print ('Robot ' + str(self.ID()) + ' done')
