''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 193

class Finder(Robot, Turner):
    def moveToRobot(self): # at least one block
        self.move()
        while not self.nextToARobot() :
            self.move()

    def slideLeft(self): # in Finder
        self.turnLeft()
        self.move()
        self.turnRight()

class Carrier(Finder):
    def carryOne(self):
       'Arithmetic carry to next column'
       pass

class Checker(Finder):
    def enoughToCarry(self):
        'Are there enough beepers to require a carry'
        pass

class Adder(Finder):
    def __init__(self,  avenue):
        Finder.__init__(self, 1, avenue, North, 0)
    
    def gatherHelpers(self):
        self.__carry = Carrier(1, 1, East, infinity)
        self.__check = Checker(1, 1, East, 0)
        self.__carry.moveToRobot()
        self.__carry.turnLeft()
        self.__check.moveToRobot()
        self.__check.turnLeft()      

    def addColumn(self):
        self.move()
        while self.nextToABeeper() :
            self.pickBeeper()
            if not self.nextToABeeper() :
                self.move()
        self.turnAround()
        while self.frontIsClear() :
            self.move()
        self.turnAround()
        self.emptyBag()
        while self.__check.enoughToCarry():
            self.__carry.carryOne()

   def carryOne(self): # Facing north on 1st Street. -- Carrier class
       'Arithmetic carry to next column'
       self.turnLeft()
       self.move()      # Note:  Error shutoff here if we try to carry
                        # from 1st Street.
       self.putBeeper() 
       self.turnAround()
       self.move()
       self.turnLeft()

    def enoughToCarry(self): # Facing north on 1st Street. Checker class
        'Are there enough beepers to require a carry'
        for i in range(10) :
            if self.nextToABeeper() :
                self.pickBeeper()
            else :
                self.emptyBag()
                return False
        # Found ten beepers. Put them on 2nd street.
        self.move()
        self.emptyBag()
        self.backUp()
        return True

    def emptyBag(self): # in Finder
        while self.anyBeepersInBeeperBag() :
            self.putBeeper()
 
    def slideLeft(self):
        Finder.slideLeft(self)
        self.__check.slideLeft()
        self.__carry.slideLeft()

    def onSecondAvenue(self):
        self.turnLeft()
        self.move()
        if self.frontIsClear() :
            self.turnAround()
            self.move()
            self.turnLeft()
            return False
        self.turnAround()
        self.move()
        self.turnLeft()
        return True

    def addAll(self):
        while not self.onSecondAvenue() :
            self.addColumn()
            self.slideLeft()
        self.addColumn() # don't forget the last column

